#ifndef TEST2CLASSES_H_
#define TEST2CLASSES_H_

#include "iopclib/iopcHeaders.h"

using namespace iopc;

class Person : public iopc::OidObject {
public:
	EShort age;
	EString name;
};

class Employee : public Person {
public:
	EInt salary;
};

class Student : public Person {
public:
	EString studcardid;

	/*static void iopcInit(iopc::Type& t) {
		t["db.mapping.type"].setStringValue("horizontal");
	}*/
};

class PhdStudent : public Student {
public:
	short int scholarship;
	DbPtr<Employee> supervisor;

	/*static void iopcInit(iopc::Type& t) {
		t["db.mapping.type"].setStringValue("filtered");
		t["db.mapping.insertto"].setStringValue("::Student");
	}*/
};

class BlacklistEntry : public iopc::DatabaseObject {
public:
	EInt externalId;
	EString name;

	static void iopcInit(iopc::Type& t) {
		t["db.table"].setStringValue("blacklist");
		t.getAttribute("externalId")["db.column"].setStringValue("id");
		t.getAttribute("externalId")["db.primaryKey"].setBoolValue(true);
		t.getAttribute("name")["db.type.length"].setIntValue(20);
		// not needed, attribute name and column name are the same:
		t.getAttribute("name")["db.column"].setStringValue("name");
	}
};

class UserTable : public iopc::DatabaseObject {
public:
	EString tableName;
	EString tablespaceName;
	EInt columnCount;

	static void iopcInit(iopc::Type& t) {
		t["db.transient"].setBoolValue(true);
		//t["db.table"].setStringValue("USER_TABLES");
		t.getAttribute("tableName")["db.column"].setStringValue("TABLE_NAME");
		t.getAttribute("tableName")["db.type.length"].setIntValue(30);
		t.getAttribute("tablespaceName")["db.column"].setStringValue("TABLESPACE_NAME");
		t.getAttribute("tablespaceName")["db.type.length"].setIntValue(30);
		//t.getAttribute("columnCount")["db.column"].setStringValue("COLUMN_COUNT");
		t.getAttribute("columnCount")["db.column.sql"].setStringValue("COUNT(*)");
	}
};

#endif /*TEST2CLASSES_H_*/
